
/*
 * Copyright 2003-2004 Broadcom Corporation. All rights reserved.
 * 
 * Redistribution and use of this Software in source and binary forms,
 * with or without modification, are permitted provided that the following
 * conditions are met:
 * 
 * 	1. Redistributions of source code must retain the above copyright
 * 	   notice, this list of conditions and the following disclaimer. 
 * 
 * 	2. Redistributions in binary form must reproduce the above copyright
 * 	   notice, this list of conditions and the following disclaimer in
 * 	   the documentation and/or other materials provided with the
 * 	   distribution.
 * 
 * 	3. This Software may be used only in connection with Broadcom
 * 	   storage integrated circuits.
 * 
 * THIS SOFTWARE IS PROVIDED BY BROADCOM CORPORATION AS IS AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL BROADCOM CORPORATION OR ITS LICENSORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * ALTERNATIVELY, provided that this notice is retained in full, this
 * product may be used, modified and/or distributed under the terms of
 * the GNU General Public License, version 2, as published by the Free
 * Software Foundation (the GPL), in which case the provisions of the GPL
 * apply INSTEAD OF those given above. A copy of the GPL is available at
 * http://www.gnu.org/copyleft/gpl.html, or by writing to the 
 * 	Free Software Foundation, Inc.
 * 	59 Temple Place - Suite 330
 * 	Boston, MA 02111-1307, USA.
 */ 

typedef struct sw_mmio_port_s {
                                                                    	//      RC_UINT32
        volatile uint32_t      PortPIOData;                             //      0
        volatile uint32_t      PortErrorFeature;                        //      1
        volatile uint32_t      PortSectorCount;                         //      2
        volatile uint32_t      PortSectorNumber;                        //      3
        volatile uint32_t      PortCylinderLow;                         //      4
        volatile uint32_t      PortCylinderHigh;                        //      5
        volatile uint32_t      PortDriveHead;                           //      6
        volatile uint32_t      PortStatusCommand;                       //      7
        volatile uint32_t      PortAlternateStatusDeviceControl;      	//      8
        volatile uint32_t      Reserved9[3];                            //      9 - 11
        volatile uint32_t      PortBusMasterCommandStatus;              //      12, command byte0, status byte1
        volatile uint32_t      DescriptorBaseAddress;                   //      13
        volatile uint32_t      Reserved14[2];                           //      14, 15
        volatile uint32_t      PortSATAStatusRegister;                  //      16      SCR0
        volatile uint32_t      PortSATAErrorRegister;                   //      17      SCR1
        volatile uint32_t      PortSATAControlRegister;                 //      18      SCR2
        volatile uint32_t      Reserved19[15];                          //      19 - 33
        volatile uint32_t      SATAInterruptMaskRegister;               //      34      SIMR
        volatile uint32_t      Reserved35[5];                           //      35 - 39
        volatile uint32_t      PortQDMALowerStartAddress;               //      40      QAL
        volatile uint32_t      PortQDMAUpperStartAddress;               //      41      QAU
        volatile uint32_t      PortQDMAProducerIndex;                   //      42      QPI
        volatile uint32_t      PortQDMAConsumerIndex;                   //      43      QCI
        volatile uint32_t      PortQDMAControlRegister;                 //      44      QCR
        volatile uint32_t      PortQDMAQueueDepthRegister;              //      45      QDR
        volatile uint32_t      PortQDMAStatusRegister;                  //      46      QSR
        volatile uint32_t      PortQDMAInterruptMaskRegister;          	//      47      QMR
        volatile uint32_t      Reserved48[16];                          //      48 - 63
} rc_sw_mmio_port_t;

#define RC_SW_MMIO_PORT_OFFSET	0x0100          //      offset 0x100 for each port

#define RC_SW_QCR_QDMA_RESET_ACK	8		//      QDMA Reset Ack
#define RC_SW_QCR_QDMA_PAUSE_ACK	2		//      QDMA Pause Ack

#define RC_SW_QCR_QDMA_RESET		8		//      QDMA Reset
#define RC_SW_QCR_QDMA_PAUSE		2		//      QDMA Pause
#define RC_SW_QCR_QDMA_ENABLE		1		//      QDMA Enable
#define RC_SW_QCR_QDMA_DISABLE		0		//      QDMA Disable

#define RC_SW_QSR_CLEAR_ALL	0x3F003F

#define RC_SW_SCR1_CLEAR_ALL	0x3FF0F03	//      write 1 to clear bit


//
//      SCR2
//
#define RC_SW_SCR2_PHY_ON                               0x0
#define RC_SW_SCR2_PHY_OFF                              0x1

